Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 2695)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 2696)
@@ -93,5 +93,5 @@
       USE oce     , ONLY:   zftu => ua       , zftv  => va         ! (ua,va) used as workspace
       USE wrk_nemo, ONLY:   zdkt => wrk_2d_1 , zdk1t => wrk_2d_2 , z2d  => wrk_2d_3   ! 2D workspace
-      USE wrk_nemo, ONLY:   zdit => wrk_3d_1 , zdjt  => wrk_3d_2 , ztfw => wrk_3d_3   ! 3D workspace
+      USE wrk_nemo, ONLY:   zdit => wrk_3d_6 , zdjt  => wrk_3d_7 , ztfw => wrk_3d_8   ! 3D workspace
       !
       INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
@@ -112,5 +112,5 @@
       !!----------------------------------------------------------------------
 
-      IF( wrk_in_use(3, 1,2,3) .OR. wrk_in_use(2, 1,2,3) ) THEN
+      IF( wrk_in_use(3, 6,7,8) .OR. wrk_in_use(2, 1,2,3) ) THEN
           CALL ctl_stop('tra_ldf_iso : requested workspace array unavailable')   ;   RETURN
       ENDIF
@@ -291,5 +291,5 @@
       END DO
       !
-      IF( wrk_not_released(3, 1,2,3) .OR.   &
+      IF( wrk_not_released(3, 6,7,8) .OR.   &
           wrk_not_released(2, 1,2,3) )   CALL ctl_stop('tra_ldf_iso: failed to release workspace arrays')
       !
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 2695)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_grif.F90	(revision 2696)
@@ -91,5 +91,5 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE oce     , ONLY:   zftu => ua       , zftv => va            ! (ua,va) used as 3D workspace
-      USE wrk_nemo, ONLY:   zdit => wrk_3d_1 , zdjt => wrk_3d_2 , ztfw => wrk_3d_3   ! 3D workspace
+      USE wrk_nemo, ONLY:   zdit => wrk_3d_6 , zdjt => wrk_3d_7 , ztfw => wrk_3d_8   ! 3D workspace
       USE wrk_nemo, ONLY:   z2d  => wrk_2d_1                                         ! 2D workspace
       !
@@ -118,5 +118,5 @@
       !!----------------------------------------------------------------------
 
-      IF( wrk_in_use(3, 1,2,3) .OR. wrk_in_use(2, 1) ) THEN
+      IF( wrk_in_use(3, 6,7,8) .OR. wrk_in_use(2, 1) ) THEN
          CALL ctl_stop('tra_ldf_iso_grif: requested workspace arrays unavailable.')   ;   RETURN
       ENDIF
@@ -125,5 +125,5 @@
       ! zdkt(:,:,1:2) instead as then wouldn't need to re-map bounds.
       ! As it is, we make zdkt a module array and allocate it in _alloc().
-      !zdkt(1:jpi,1:jpj,0:1) => wrk_3d_4(:,:,1:2)
+      !zdkt(1:jpi,1:jpj,0:1) => wrk_3d_9(:,:,1:2)
 
       IF( kt == nit000 )  THEN
@@ -348,5 +348,5 @@
       END DO
       !
-      IF( wrk_not_released(3, 1,2,3,4) .OR.   &
+      IF( wrk_not_released(3, 6,7,8) .OR.   &
           wrk_not_released(2, 1)       )   CALL ctl_stop('tra_ldf_iso_grif: failed to release workspace arrays')
       !
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_exp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 2695)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 2696)
@@ -74,5 +74,5 @@
       !!---------------------------------------------------------------------
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   zwx => wrk_3d_1, zwy => wrk_3d_2     ! 3D workspace
+      USE wrk_nemo, ONLY:   zwx => wrk_3d_6, zwy => wrk_3d_7     ! 3D workspace
       !
       INTEGER                              , INTENT(in   ) ::   kt          ! ocean time-step index
@@ -89,5 +89,5 @@
       !!---------------------------------------------------------------------
 
-      IF( wrk_in_use(3, 1,2) ) THEN
+      IF( wrk_in_use(3, 6,7) ) THEN
          CALL ctl_stop('tra_zdf_exp: requested workspace arrays unavailable')   ;   RETURN
       ENDIF
@@ -164,5 +164,5 @@
       END DO
       !
-      IF( wrk_not_released(3, 1,2) )   CALL ctl_stop('tra_zdf_exp: failed to release workspace arrays')
+      IF( wrk_not_released(3, 6,7) )   CALL ctl_stop('tra_zdf_exp: failed to release workspace arrays')
       !
    END SUBROUTINE tra_zdf_exp
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 2695)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 2696)
@@ -76,5 +76,5 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE oce     , ONLY:   zwd => ua       , zws => va         ! (ua,va) used as 3D workspace
-      USE wrk_nemo, ONLY:   zwi => wrk_3d_1 , zwt => wrk_3d_2   ! 3D workspace 
+      USE wrk_nemo, ONLY:   zwi => wrk_3d_6 , zwt => wrk_3d_7   ! 3D workspace 
       !
       INTEGER                              , INTENT(in   ) ::   kt       ! ocean time-step index
@@ -89,5 +89,5 @@
       !!---------------------------------------------------------------------
 
-      IF( wrk_in_use(3, 1,2) ) THEN
+      IF( wrk_in_use(3, 6,7) ) THEN
          CALL ctl_stop('tra_zdf_imp : requested workspace arrays unavailable.')   ;   RETURN
       ENDIF
@@ -228,5 +228,5 @@
       !                                               ! ================= !
       !
-      IF( wrk_not_released(3, 1,2) )   CALL ctl_stop('tra_zdf_imp: failed to release workspace arrays')
+      IF( wrk_not_released(3, 6,7) )   CALL ctl_stop('tra_zdf_imp: failed to release workspace arrays')
       !
    END SUBROUTINE tra_zdf_imp