Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ANT_Icethick_MARS.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ANT_Icethick_MARS.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ANT_Icethick_MARS.pro	(revision 2711)
@@ -13,4 +13,5 @@
                                 ; 
  title=sEXP1+' Antartic Ice Thickness MARS / year '+start_end
+ varunit = Ithi_mars_1.unit
 
 ;SF Ithi_mars_1.arr = Ithi_mars_1.arr < 1.
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ANT_Icethick_SEPT.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ANT_Icethick_SEPT.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ANT_Icethick_SEPT.pro	(revision 2711)
@@ -13,4 +13,5 @@
                                 ; 
  title=sEXP1+' Antartic Ice Thickness SEPT / year '+start_end
+ varunit = Ithi_sept_1.unit
 
 ;SF Ithi_sept_1.arr = Ithi_sept_1.arr < 1.
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ARC_Icethick_MARS.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ARC_Icethick_MARS.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ARC_Icethick_MARS.pro	(revision 2711)
@@ -12,6 +12,7 @@
  domdef,20,380,55,90
            
+ varunit = Ithi_mars_1.unit
+;
  title=sEXP1+' Arctic Ice Thickness MARS/ year '+start_end
-
 ;SF  Ithi_mars_1.arr = Ithi_mars_1.arr < 6.
  plt, Ithi_mars_1.arr - 1.E-04, MIN = 0., MAX = 9.5, INTER = 0.5 ,/STRICTFILL , CELL_FILL = 2, STYLE = 'so0so'  $
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ARC_Icethick_SEPT.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ARC_Icethick_SEPT.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_ARC_Icethick_SEPT.pro	(revision 2711)
@@ -13,4 +13,5 @@
            
  title=sEXP1+' Arctic Ice Thickness SEPT / year '+start_end
+ varunit = Ithi_sept_1.unit
 
 ;SF  Ithi_sept_1.arr = Ithi_sept_1.arr < 6.
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Emp.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Emp.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Emp.pro	(revision 2711)
@@ -1,4 +1,5 @@
 pro xxx_Emp, EMP1, EMP2, sEXP1, sEXP2, start_end, POSTSCRIPT = postscript, _extra = ex
   
+  @common
  
   compile_opt idl2, strictarrsubs
@@ -9,4 +10,5 @@
   
   title=sEXP1+' Emp (mm/day) / year '+start_end
+  varunit= 'mm/day'
   plt, EMP1,  MIN = -10., MAX = 10., INTER = 1. $
        , small = [1,2,1], COAST_THICK = 2, TITLE = title, /PORTRAIT, _extra=ex
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Erp.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Erp.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Erp.pro	(revision 2711)
@@ -1,4 +1,5 @@
 pro xxx_Erp, ERP1, ERP2, sEXP1, sEXP2, start_end, POSTSCRIPT = postscript, _extra = ex
-  
+
+@common
  
   compile_opt idl2, strictarrsubs
@@ -9,4 +10,5 @@
   
   title=sEXP1+' Erp (mm/day) / year '+start_end
+  varunit= 'mm/day'
   plt, ERP1,  MIN = -5., MAX = 5., INTER = .5 $
        , small = [1,2,1], COAST_THICK = 2, TITLE = title, /PORTRAIT, _extra=ex
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Med_S_depth.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Med_S_depth.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Med_S_depth.pro	(revision 2711)
@@ -13,5 +13,7 @@
 ;domdef,270,365,5,70
    minval = min(abs(gdept -  depth),index)
-   
+;
+   varunit = S1.unit
+;  
    title = sEXP1+'  Mediterranean water at ' +strtrim(lat,1)+'°N / year '+start_end 
    pltz, S1.arr, MININ = 35., MAXIN = 37., INTER = 0.1,  UNIT = varunit $
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Med_S_tongue.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Med_S_tongue.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_Med_S_tongue.pro	(revision 2711)
@@ -13,5 +13,7 @@
 ;domdef,270,365,5,70
 minval = min(abs(gdept -  depth),index)
-  
+;
+varunit = S1.unit
+;  
    title = sEXP1+' Mediterranean salt tongue at depth=' + strtrim(gdept[index],1)+' m / year '+start_end
    plt, S1.arr, MININ=35., MAXIN=37., INTER=0.1,  UNIT= varunit $
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_TS_ZGlobm.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_TS_ZGlobm.pro	(revision 2709)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/xxx_TS_ZGlobm.pro	(revision 2711)
@@ -8,15 +8,16 @@
  endif
 
-                                ;
+ varunit = T1.unit
  title=sEXP1+' (Black) & '+sEXP2+' (Red) - Levitus Temp. Global mean / year '+start_end
  plt1d, T1.arr - TLev.arr, typein = 'z', ticklen = 1 , MIN = -2., MAX = 2., boxzoom = [4.,5300.], /KEEPBOTTOM $
-        , small = [1,2,1], XGRIDSTYLE = 2, YGRIDSTYLE = 2, UNIT = varunit, TITLE = title, _extra = ex
+        , small = [1,2,1], XGRIDSTYLE = 2, YGRIDSTYLE = 2, TITLE = title, _extra = ex
  plt1d, T2.arr - TLev.arr, typein = 'z',  ticklen = 1 , MIN = -2., MAX = 2., boxzoom = [4.,5300.], /KEEPBOTTOM  $
         , /ov1d, COLOR = 250,TITLE = title, _extra = ex 
                                 ;
 
+ varunit = S1.unit
  title=sEXP1+'(Black) & '+sEXP2+' (Red) - Levitus Sal. Global mean / year '+start_end
  plt1d, S1.arr - SLev.arr, typein = 'z', ticklen = 1 , MIN = -.2, MAX = .2, boxzoom = [4.,5300.], /KEEPBOTTOM $
-        , small = [1,2,2], XGRIDSTYLE = 2, YGRIDSTYLE = 2, UNIT = varunit, TITLE = title, /NOERASE, _extra = ex
+        , small = [1,2,2], XGRIDSTYLE = 2, YGRIDSTYLE = 2, TITLE = title, /NOERASE, _extra = ex
  plt1d, S2.arr - SLev.arr, typein = 'z',  ticklen = 1 , MIN = -2., MAX = 2., boxzoom = [4.,5300.], /KEEPBOTTOM $
         ,  /ov1d, COLOR = 250, TITLE = title, _extra = ex 