Index: /trunk/NEMOGCM/SETTE/README
===================================================================
--- /trunk/NEMOGCM/SETTE/README	(revision 2715)
+++ /trunk/NEMOGCM/SETTE/README	(revision 2716)
@@ -9,5 +9,5 @@
 USER MODIFICATIONS
  in sette.sh script :
-               SETTE_DIR : base directory for SETTE
+               CMP_NAM     : compiler among those available in NEMOGCM/ARCH, needed for makenemo (see below)
                makenemo -m : machine (compilator); see ./makenemo -m help (in NEMOGCM/CONFIG directory)
                         -n : config name (in examples config_name_nproci_nprocj), see ./makenemo -n help
@@ -21,5 +21,5 @@
 			(  	 : to activate control print : namelist ln_ctl false )
                fcm_job.sh needs input: input_CONFIG_NAME TOTAL_NUMBER_OF_PROCS_used TEST_NAME
-			(for example if you compile ORCA2_LIM with nproci=2 and nprocj=2 
+			(for example if you compile ORCA2_LIM with key_mpp_mpi 
 			and only run short test ===> ./fcm_job input_ORCA2_LIM.cfg 4 SHORT)
  in param.cfg :
Index: /trunk/NEMOGCM/SETTE/sette.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/sette.sh	(revision 2715)
+++ /trunk/NEMOGCM/SETTE/sette.sh	(revision 2716)
@@ -110,6 +110,16 @@
 #-
 #
-
-SETTE_DIR=/PATH/OF/SETTE
+#-
+# Compiler among those in NEMOGCM/ARCH
+CMP_NAM=$1
+
+# Directory to run the tests
+SETTE_DIR=$(cd $(dirname "$0"); pwd)
+MAIN_DIR=${SETTE_DIR%/SETTE}
+CONFIG_DIR=${MAIN_DIR}/CONFIG
+TOOLS_DIR=${MAIN_DIR}/TOOLS
+COMPIL_DIR=${TOOLS_DIR}/COMPILE
+# Check if a compiler has already been defined
+. ${COMPIL_DIR}/Fcheck_archfile.sh arch_nemo.fcm ${CMP_NAM} || exit
 
 ## NBTEST=6
@@ -123,5 +133,5 @@
     # Restartability tests for GYRE_LOBSTER
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6MONO_VARGAS -n GYRELOB_LONG -r GYRE_LOBSTER del_key "key_diatrc"
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_LONG -r GYRE_LOBSTER del_key "key_diatrc"
     cd ${SETTE_DIR}
     . param.cfg
@@ -131,9 +141,9 @@
     set_namelist namelist nn_itend 120
     set_namelist namelist nn_stock 60
+    set_namelist namelist ln_clobber .true.
     set_namelist namelist_top ln_trcrad .false.
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_GYRE.cfg 1 LONG
     
-    cd ${SETTE_DIR}
     set_namelist namelist cn_exp \"GYRELOB_SHORT\"
     set_namelist namelist nn_it000 61
@@ -142,5 +152,6 @@
     set_namelist namelist ln_rstart .true.
     set_namelist namelist nn_rstctl 2
-    set_namelist namelist cn_ocerst_in \"GYRELOB_LONG_00000060_restart\"
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist cn_ocerst_in \"GYRELOB_LONG_00000060_restart.nc\"
     set_namelist namelist_top ln_trcrad .false.
     set_namelist namelist_top ln_rsttr .true.
@@ -152,7 +163,7 @@
 
 if [ ${config} -eq 2 ] ;  then
-    # Restartability tests for ORCA2_LIM_PISCES
-    cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6MONO_VARGAS -n ORCA2LIMPIS_LONG -r ORCA2_LIM_PISCES del_key "key_dtatrc key_diatrc"
+# Restartability tests for ORCA2_LIM_PISCES
+    cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_LONG -r ORCA2_LIM_PISCES del_key "key_dtatrc key_diatrc"
     cd ${SETTE_DIR}
     . param.cfg
@@ -162,4 +173,5 @@
     set_namelist namelist nn_itend 150
     set_namelist namelist nn_stock 75
+    set_namelist namelist ln_clobber .true.
     set_namelist namelist_top ln_trcrad .false.
     # put ln_pisdmp, ln_dustfer, ln_river, ln_ndepo, ln_sedinput to false
@@ -174,4 +186,6 @@
     
     cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -n ORCA2LIMPIS_SHORT -r ORCA2_LIM_PISCES del_key "key_dtatrc key_diatrc"
+    cd ${SETTE_DIR}
     . param.cfg
     . all_functions.sh
@@ -182,6 +196,7 @@
     set_namelist namelist ln_rstart .true.
     set_namelist namelist nn_rstctl 2
-    set_namelist namelist cn_ocerst_in \"O2LP_LONG_00000075_restart\"
-    set_namelist namelist_ice_lim2 cn_icerst_in \"O2LP_LONG_00000075_restart_ice\"
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist cn_ocerst_in \"O2LP_LONG_00000075_restart.nc\"
+    set_namelist namelist_ice cn_ocerst_in \"O2LP_LONG_00000075_restart_ice.nc\"
     set_namelist namelist_top ln_trcrad .false.
     set_namelist namelist_top ln_rsttr .true.
@@ -200,7 +215,7 @@
 
 if [ ${config} -eq 3 ] ;  then
-    ## Restartability tests for POMME 
-    cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6MONO_VARGAS -n POMME_LONG -r POMME
+    ## Restartability tests for POMME
+    cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -m gfortran_linux -n POMME_LONG -r POMME
     cd ${SETTE_DIR}
     . param.cfg
@@ -209,10 +224,7 @@
     set_namelist namelist nn_it000 1
     set_namelist namelist nn_itend 600
-    set_namelist namelist nn_stock 300
-    set_namelist namelist nn_write 300
+    set_namelist namelist ln_clobber .true.
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_POMME.cfg 1 LONG
-    cd ${CONFIG_DIR}
-    `mv ${NEW_CONF}/EXP00/restart.obc.output ${NEW_CONF}/EXP00/restart.obc`
     
     cd ${SETTE_DIR}
@@ -223,6 +235,7 @@
     set_namelist namelist ln_rstart .true.
     set_namelist namelist nn_rstctl 2
-    set_namelist namelist nn_write 300
-    set_namelist namelist cn_ocerst_in \"POMME_LONG_00000300_restart\"
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist cn_ocerst_in \"POMME_LONG_00000075_restart.nc\"
+    mv ${OUTPUT_DIR}/restart.obc.output ${OUTPUT_DIR}/restart.obc
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_POMME.cfg 1 SHORT
@@ -230,7 +243,7 @@
 
 if [ ${config} -eq 4 ] ;  then
-    ## Repropducilibity tests for GYRE_LOBSTER
-    cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6_VARGAS -n GYRELOB_1_4 -r GYRE_LOBSTER add_key "key_mpp_mpi key_mpp_rep key_nproci=1 key_nprocj=4" del_key "key_vectopt_loop key_diatrc"
+    ## Reproducilibity tests for GYRE_LOBSTER
+    cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_1_4 -r GYRE_LOBSTER add_key "key_mpp_mpi key_mpp_rep" del_key "key_vectopt_loop key_diatrc"
     cd ${SETTE_DIR}
     . param.cfg
@@ -241,9 +254,13 @@
     set_namelist namelist nn_bench 0
     set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 1
+    set_namelist namelist jpnj 4
+    set_namelist namelist jpnij 4
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_GYRE.cfg 4 SHORT
     
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6_VARGAS -n GYRELOB_2_2 -r GYRE_LOBSTER add_key "key_mpp_rep key_mpp_mpi key_nproci=2 key_nprocj=2" del_key "key_vectopt_loop key_diatrc"
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n GYRELOB_2_2 -r GYRE_LOBSTER add_key "key_mpp_rep key_mpp_mpi" del_key "key_vectopt_loop key_diatrc"
     cd ${SETTE_DIR}
     . param.cfg
@@ -252,6 +269,9 @@
     set_namelist namelist nn_itend 75
     set_namelist namelist nn_fwb 0
-    set_namelist namelist nn_bench 0
-    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_GYRE.cfg 4 SHORT
@@ -261,5 +281,5 @@
     ## Repropducilibity tests for ORCA2_LIM_PISCES
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6_VARGAS -n ORCA2LIMPIS_4_4 -r ORCA2_LIM_PISCES add_key "key_mpp_mpi key_mpp_rep key_nproci=4 key_nprocj=4" del_key "key_vectopt_loop key_dtatrc key_diatrc" 
+    . ../CONFIG/makenemo -m ${CMP_NAM} -n ORCA2LO2LPO2LP_4_4 -r ORCA2_LIM_PISCES add_key "key_mpp_mpi key_mpp_rep" del_key "key_vectopt_loop key_dtatrc key_diatrc" 
     cd ${SETTE_DIR}
     . param.cfg
@@ -268,6 +288,9 @@
     set_namelist namelist nn_itend 75
     set_namelist namelist nn_fwb 0
-    set_namelist namelist nn_bench 0
-    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 4
+    set_namelist namelist jpnj 4
+    set_namelist namelist jpnij 16 
     # put ln_pisdmp, ln_dustfer, ln_river, ln_ndepo, ln_sedinput to false
     # if not you need input files, and for tests is not necessary
@@ -279,7 +302,7 @@
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_ORCA2_LIM_PISCES.cfg 16 SHORT
-
-    cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6_VARGAS -n ORCA2LIMPIS_2_8 -r ORCA2_LIM_PISCES add_key "key_mpp_rep key_mpp_mpi key_nproci=2 key_nprocj=8" del_key "key_vectopt_loop key_dtatrc key_diatrc"
+    
+    cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -n ORCA2LIMPIS_2_8 -r ORCA2_LIM_PISCES add_key "key_mpp_rep key_mpp_mpi" del_key "key_vectopt_loop key_dtatrc key_diatrc"
     cd ${SETTE_DIR}
     . param.cfg
@@ -288,6 +311,9 @@
     set_namelist namelist nn_itend 75
     set_namelist namelist nn_fwb 0
-    set_namelist namelist nn_bench 0
-    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 8
+    set_namelist namelist jpnij 16
     # put ln_pisdmp, ln_dustfer, ln_river, ln_ndepo, ln_sedinput to false
     # if not you need input files, and for tests is not necessary
@@ -302,7 +328,7 @@
 
 if [ ${config} -eq 6 ] ;  then
-    ## Reproductibility tests for POMME 
-    cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6_VARGAS -n POMME_1_4 -r POMME add_key "key_mpp_mpi key_mpp_rep key_nproci=1 key_nprocj=4"
+    ## Reproductibility tests for POMME
+    cd ${SETTE_DIR}
+    . ../CONFIG/makenemo -m gfortran_linux -n POMME_1_4 -r POMME add_key "key_mpp_mpi key_mpp_rep"
     cd ${SETTE_DIR}
     . param.cfg
@@ -311,11 +337,14 @@
     set_namelist namelist nn_itend 300
     set_namelist namelist nn_fwb 0
-    set_namelist namelist nn_bench 0
-    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 1
+    set_namelist namelist jpnj 4
+    set_namelist namelist jpnij 4
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_POMME.cfg 4 SHORT
     
     cd ${SETTE_DIR}
-    . ../CONFIG/makenemo -m PW6_VARGAS -n POMME_2_2 -r POMME add_key "key_mpp_mpi key_mpp_rep key_nproci=2 key_nprocj=2" 
+    . ../CONFIG/makenemo -m gfortran_linux -n POMME_2_2 -r POMME add_key "key_mpp_mpi key_mpp_rep"
     cd ${SETTE_DIR}
     . param.cfg
@@ -324,6 +353,9 @@
     set_namelist namelist nn_itend 300
     set_namelist namelist nn_fwb 0
-    set_namelist namelist nn_bench 0
-    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_ctl .false.
+    set_namelist namelist ln_clobber .true.
+    set_namelist namelist jpni 2
+    set_namelist namelist jpnj 2
+    set_namelist namelist jpnij 4
     cd ${SETTE_DIR}
     . ./fcm_job.sh input_POMME.cfg 4 SHORT
Index: /trunk/NEMOGCM/SETTE/sette_beginner.sh
===================================================================
--- /trunk/NEMOGCM/SETTE/sette_beginner.sh	(revision 2715)
+++ /trunk/NEMOGCM/SETTE/sette_beginner.sh	(revision 2716)
@@ -37,8 +37,8 @@
 #-
 #
-SETTE_DIR=/PATH/OF/SETTE
+SETTE_DIR=$(cd $(dirname "$0"); pwd)
 # Run for GYRE CONFIG
 # small test to start
-# compile GYRE configuration with gfortran_osx compiler run with 1 proc, by default in cpp_GYRE.fcm file : key_nproci=1 key_nprocj=1
+# compile GYRE configuration with gfortran_osx compiler run with 1 proc, by default in cpp_GYRE.fcm file : 
 cd ${SETTE_DIR}
 . ../CONFIG/makenemo -m gfortran_osx -n GYRE_SHORT -r GYRE