Index: /trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 2747)
+++ /trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 2748)
@@ -755,21 +755,21 @@
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released, iwrk_in_use, iwrk_not_released
-      USE wrk_nemo, ONLY: dU10 => wrk_2d_1        ! dU                             [m/s]
-      USE wrk_nemo, ONLY: dT => wrk_2d_2          ! air/sea temperature difference   [K]
-      USE wrk_nemo, ONLY: dq => wrk_2d_3          ! air/sea humidity difference      [K]
-      USE wrk_nemo, ONLY: Cd_n10 => wrk_2d_4      ! 10m neutral drag coefficient
-      USE wrk_nemo, ONLY: Ce_n10 => wrk_2d_5      ! 10m neutral latent coefficient
-      USE wrk_nemo, ONLY: Ch_n10 => wrk_2d_6      ! 10m neutral sensible coefficient
-      USE wrk_nemo, ONLY: sqrt_Cd_n10 => wrk_2d_7 ! root square of Cd_n10
-      USE wrk_nemo, ONLY: sqrt_Cd => wrk_2d_8     ! root square of Cd
-      USE wrk_nemo, ONLY: T_vpot => wrk_2d_9      ! virtual potential temperature    [K]
-      USE wrk_nemo, ONLY: T_star => wrk_2d_10     ! turbulent scale of tem. fluct.
-      USE wrk_nemo, ONLY: q_star => wrk_2d_11     ! turbulent humidity of temp. fluct.
-      USE wrk_nemo, ONLY: U_star => wrk_2d_12     ! turb. scale of velocity fluct.
-      USE wrk_nemo, ONLY: L => wrk_2d_13          ! Monin-Obukov length              [m]
-      USE wrk_nemo, ONLY: zeta_u => wrk_2d_14     ! stability parameter at height zu
-      USE wrk_nemo, ONLY: zeta_t => wrk_2d_15     ! stability parameter at height zt
-      USE wrk_nemo, ONLY: U_n10 => wrk_2d_16      ! neutral wind velocity at 10m     [m]
-      USE wrk_nemo, ONLY: xlogt => wrk_2d_17, xct => wrk_2d_18, zpsi_hu => wrk_2d_19, zpsi_ht => wrk_2d_20, zpsi_m => wrk_2d_21
+      USE wrk_nemo, ONLY: dU10 => wrk_2d_14        ! dU                             [m/s]
+      USE wrk_nemo, ONLY: dT => wrk_2d_15          ! air/sea temperature difference   [K]
+      USE wrk_nemo, ONLY: dq => wrk_2d_16          ! air/sea humidity difference      [K]
+      USE wrk_nemo, ONLY: Cd_n10 => wrk_2d_17      ! 10m neutral drag coefficient
+      USE wrk_nemo, ONLY: Ce_n10 => wrk_2d_18      ! 10m neutral latent coefficient
+      USE wrk_nemo, ONLY: Ch_n10 => wrk_2d_19      ! 10m neutral sensible coefficient
+      USE wrk_nemo, ONLY: sqrt_Cd_n10 => wrk_2d_20 ! root square of Cd_n10
+      USE wrk_nemo, ONLY: sqrt_Cd => wrk_2d_21     ! root square of Cd
+      USE wrk_nemo, ONLY: T_vpot => wrk_2d_22      ! virtual potential temperature    [K]
+      USE wrk_nemo, ONLY: T_star => wrk_2d_23     ! turbulent scale of tem. fluct.
+      USE wrk_nemo, ONLY: q_star => wrk_2d_24     ! turbulent humidity of temp. fluct.
+      USE wrk_nemo, ONLY: U_star => wrk_2d_25     ! turb. scale of velocity fluct.
+      USE wrk_nemo, ONLY: L => wrk_2d_26          ! Monin-Obukov length              [m]
+      USE wrk_nemo, ONLY: zeta_u => wrk_2d_27     ! stability parameter at height zu
+      USE wrk_nemo, ONLY: zeta_t => wrk_2d_28     ! stability parameter at height zt
+      USE wrk_nemo, ONLY: U_n10 => wrk_2d_29      ! neutral wind velocity at 10m     [m]
+      USE wrk_nemo, ONLY: xlogt => wrk_2d_30, xct => wrk_2d_31, zpsi_hu => wrk_2d_32, zpsi_ht => wrk_2d_33, zpsi_m => wrk_2d_34
       USE wrk_nemo, ONLY: stab => iwrk_2d_1      ! 1st guess stability test integer
       !!
@@ -798,8 +798,10 @@
       !!  * Start
 
-      IF(  wrk_in_use(2, 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21) .OR. &
-          iwrk_in_use(2, 1) ) THEN
+      IF(  wrk_in_use(2,             14,15,16,17,18,19,        &
+                         20,21,22,23,24,25,26,27,28,29,        &         
+                         30,31,32,33,34)                .OR.   &
+          iwrk_in_use(2, 1)                               ) THEN
          CALL ctl_stop('TURB_CORE_2Z: requested workspace arrays unavailable')   ;   RETURN
-      END IF
+      ENDIF
 
       !! Initial air/sea differences
@@ -876,6 +878,9 @@
       END DO
       !!
-      IF(  wrk_not_released(2, 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21) .OR.   &
-          iwrk_not_released(2, 1)    )   CALL ctl_stop('TURB_CORE_2Z: requested workspace arrays unavailable')
+     IF( wrk_not_released(2,              14,15,16,17,18,19,          &
+         &                    20,21,22,23,24,25,26,27,28,29,          &
+         &                    30,31,32,33,34                )   .OR.  &  
+         iwrk_not_released(2, 1)                                  )   &
+         CALL ctl_stop('TURB_CORE_1Z: failed to release workspace arrays')
       !
     END SUBROUTINE TURB_CORE_2Z
@@ -885,7 +890,7 @@
       !-------------------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:     X2 => wrk_2d_33
-      USE wrk_nemo, ONLY:     X  => wrk_2d_34
-      USE wrk_nemo, ONLY: stabit => wrk_2d_35
+      USE wrk_nemo, ONLY:     X2 => wrk_2d_35
+      USE wrk_nemo, ONLY:     X  => wrk_2d_36
+      USE wrk_nemo, ONLY: stabit => wrk_2d_37
       !!
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: zta
@@ -895,5 +900,5 @@
       !-------------------------------------------------------------------------------
 
-      IF( wrk_in_use(2, 33,34,35) ) THEN
+      IF( wrk_in_use(2, 35,36,37) ) THEN
          CALL ctl_stop('psi_m: requested workspace arrays unavailable')   ;   RETURN
       ENDIF
@@ -904,5 +909,5 @@
          &    + (1. - stabit)*(2*log((1. + X)/2) + log((1. + X2)/2) - 2*atan(X) + pi/2)  ! Unstable 
 
-      IF( wrk_not_released(2, 33,34,35) )   CALL ctl_stop('psi_m: failed to release workspace arrays')
+      IF( wrk_not_released(2, 35,36,37) )   CALL ctl_stop('psi_m: failed to release workspace arrays')
       !
     END FUNCTION psi_m
@@ -912,7 +917,7 @@
       !-------------------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:     X2 => wrk_2d_33
-      USE wrk_nemo, ONLY:     X  => wrk_2d_34
-      USE wrk_nemo, ONLY: stabit => wrk_2d_35
+      USE wrk_nemo, ONLY:     X2 => wrk_2d_35
+      USE wrk_nemo, ONLY:     X  => wrk_2d_36
+      USE wrk_nemo, ONLY: stabit => wrk_2d_37
       !
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   zta
@@ -921,5 +926,5 @@
       !-------------------------------------------------------------------------------
 
-      IF( wrk_in_use(2, 33,34,35) ) THEN
+      IF( wrk_in_use(2, 35,36,37) ) THEN
          CALL ctl_stop('psi_h: requested workspace arrays unavailable')   ;   RETURN
       ENDIF
@@ -930,5 +935,5 @@
          &    + (1. - stabit)*(2.*log( (1. + X2)/2. ))                 ! Unstable
 
-      IF( wrk_not_released(2, 33,34,35) )   CALL ctl_stop('psi_h: failed to release workspace arrays')
+      IF( wrk_not_released(2, 35,36,37) )   CALL ctl_stop('psi_h: failed to release workspace arrays')
       !
     END FUNCTION psi_h