Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_S100m.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_S100m.pro	(revision 2759)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_S100m.pro	(revision 2760)
@@ -16,14 +16,14 @@
   title = 'Salinity ('+sdepref+')!C'+std_file1_T
   plt, S1, MIN = 33., MAX = 38.2, INTER = .2, format = '(f4.1)' $
-       , small = [1, 2, 1], COAST_THICK = 2, TITLE = title, boxzoom = [105., 106.], /PORTRAIT, _extra = ex
+       , small = [1, 2, 1], COAST_THICK = 2, TITLE = title, boxzoom = [floor(gdept[ind]), ceil(gdept[ind])], /PORTRAIT, _extra = ex
 ;
   if std_file1_T NE std_file2_T then begin
     title = title+ ' - '+std_file2_T
     plt, S1.arr[*, *, 0] - S2.arr[*, *, 0], MIN = -1., MAX = 1., INTER = .1, STYLE = 'so0so', format = '(f4.1)' $
-         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [105., 106.], /noerase, _extra = ex   
+         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [floor(gdept[ind]), ceil(gdept[ind])], /noerase, _extra = ex   
   endif else begin
     title = title+ ' - Levitus'
     plt, S1.arr-SLev.arr, MIN = -1., MAX = 1., INTER = 0.1, STYLE = 'so0so', format = '(f4.1)' $
-         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [105., 106.], /noerase, _extra = ex
+         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [floor(gdept[ind]), ceil(gdept[ind])], /noerase, _extra = ex
   endelse
 
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_T100m.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_T100m.pro	(revision 2759)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_T100m.pro	(revision 2760)
@@ -16,14 +16,14 @@
   title = 'Temperature ('+sdepref+')!C'+std_file1_T
   plt, T1, MIN = -2., MAX = 32., INTER = 1., FORMAT = '(I2)'  $
-       , small = [1, 2, 1], COAST_THICK = 2, TITLE = title, boxzoom = [105., 106.], /portrait, _extra = ex
+       , small = [1, 2, 1], COAST_THICK = 2, TITLE = title, boxzoom = [floor(gdept[ind]), ceil(gdept[ind])], /portrait, _extra = ex
 ;
   IF std_file1_T NE std_file2_T THEN BEGIN
     title = title+ ' - '+std_file2_T
     plt, T1.arr - T2.arr, MIN = -2., MAX = 2., INTER = .2, STYLE = 'so0so', FORMAT = '(f4.1)' $
-         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [105., 106.], /noerase,  _extra = ex
+         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [floor(gdept[ind]), ceil(gdept[ind])], /noerase,  _extra = ex
   ENDIF ELSE BEGIN
     title = title+ ' - Levitus'
-    plt, T1.arr - TLev.arr, MIN = -4., MAX = 4., INTER = .5, STYLE = 'so0so', FORMAT = '(I2)'  $
-         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [105., 106.], /noerase, _extra = ex   
+    plt, T1.arr - TLev.arr, MIN = -5., MAX = 5., INTER = .5, STYLE = 'so0so', FORMAT = '(I2)'  $
+         , small = [1, 2, 2], COAST_THICK = 2, TITLE = title, boxzoom = [floor(gdept[ind]), ceil(gdept[ind])], /noerase, _extra = ex   
   ENDELSE
 ;
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_mht.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_mht.pro	(revision 2759)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_mht.pro	(revision 2760)
@@ -54,5 +54,5 @@
   subtitle = '(Qnet='+ibce1+' W/m2)'
   plt1d, htr1, 'y', min = -2., max = 2.5, TITLE = title, SUBTITLE = subtitle, /portrait $ 
-         , SMALL = [2, 2, 1], YTITLE = 'PW',  XGRIDSTYLE = 2, TICKLEN = 1, YGRIDSTYLE = 2, _extra = ex
+         , SMALL = [2-(std_file1_T EQ std_file2_T), 2, 1], YTITLE = 'PW',  XGRIDSTYLE = 2, TICKLEN = 1, YGRIDSTYLE = 2, _extra = ex
   plt1d, htr1_atl, 'y', COLOR = 50, /ov1d,  _extra = ex
 
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_msf.pro
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_msf.pro	(revision 2759)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM/IDL_scripts/std_plot_msf.pro	(revision 2760)
@@ -33,5 +33,5 @@
   domdef, 0, 6000
 
-  mm1 = msf(V1.arr, indexboxzoom = ind, maskout = ma)
+  mm1 = msf(V1.arr, msk, indexboxzoom = ind, maskout = ma)
   title = 'Meridional Stream Function, '+subname+'!C'+std_file1_V
   pltz, mm1, 'yz', -20., 20., int = 1., boxzoom = [ind[0:1], lat_ext, 0, 5500], /xindex, FORMAT = '(I3)', /portrait $
@@ -39,5 +39,5 @@
 
   if std_file1_V NE std_file2_V then begin
-    mm2 = msf(V2.arr, indexboxzoom = ind, maskout = ma)
+    mm2 = msf(V2.arr, msk, indexboxzoom = ind, maskout = ma)
     title = title+' - '+std_file2_V
     pltz, mm1.arr-mm2.arr, 'yz', -10., 10., int = 1., boxzoom = [ind[0:1], lat_ext, 0, 5500], /xindex,  FORMAT = '(I3)'  $